<'
import evc_util/e/evc_util_top.e;

extend any_struct { 
    get_non_zero_objs(input_obj_kind : string) is {
      var all_obj_types : list of objection_kind; 
      var obj_units : list of any_unit;
      var all_units : list of any_unit = get_all_units(any_unit);

      if input_obj_kind == "all" then {
      	 all_obj_types = all_values(objection_kind);
      } else {
      	 all_obj_types.add(input_obj_kind.as_a(objection_kind));
      };
      
      
      outf("\n\n%-6s %-6s %-5s\n", "e Path", "OBJ Type", "No. of OBJs");
      for each (obj_type) in all_obj_types {
      	 for each (u) in all_units {
	    if (u.get_objection_total(obj_type) > 0) then {
	       outf ("%-6s %-6s %-5d\n", 
	          u.e_path(), obj_type, u.get_objection_counter(obj_type));
	    };
	 };
      };
      outf("\n\n\n");
   };

   get_non_zero_objs_vt(input_obj_kind : string) : list of string is {
   
      var all_obj_types : list of objection_kind;
      var obj_units : list of any_unit;
      var all_units : list of any_unit = get_all_units(any_unit);
      
      if input_obj_kind == "all" then {
      	 all_obj_types = all_values(objection_kind);
      } else {
      	 all_obj_types.add(input_obj_kind.as_a(objection_kind));
      };      
      
      for each (obj_type) in all_obj_types {
      	 for each (u) in all_units {
	    if (u.get_objection_total(obj_type) > 0) then {
	       result.add("<TR>");
	       result.add("<TD>");
	       result.add(obj_type.as_a(string));
	       result.add("</TD>");
      	       result.add("<TD>");
	       result.add(u.get_objection_counter(obj_type).as_a(string));
	       result.add("</TD>");	       
      	       result.add("<TD>");
	       result.add(u.e_path().as_a(string));
	       result.add("</TD>");
	       result.add("</TR>");
	       outf ("%-6s %-6s %-5d\n", 
	          u.e_path(), obj_type, u.get_objection_counter(obj_type));
	    };
	 };
      };
      outf("\n\n\n");
   };
      
};


'>
