<'
import shr_obj_cntr.e;

display user menu "Browse Non-Zero Objections" "sys.shr_obj_viewer.show_viewer()";
extend vt_window_kind: [MY_WINDOW];

extend MY_WINDOW vt_window {
    configure() is also {
        set_location(250, 100);
        set_size(600, 500);
       set_title_prefix("CPU Pipeline Viewer");
 
    };
};

extend vt_page_kind: [MY_PAGE];

extend MY_PAGE vt_page {
   configure() is also {
   };
};

struct shr_obj_viewer_s {
   !content : list of string;
   !obj_viewer : vt_page;
      
   init() is also {
      obj_viewer = new MY_PAGE vt_page with {
      	 .set_window_kind(MY_WINDOW);
      };
   };
   
   build_viewer_content(obj : string) is {
      var tmp_obj_viewer : vt_page = new MY_PAGE vt_page with {
      	 .set_window_kind(MY_WINDOW);
      };
      
      content.clear();
      
      content.add("<CENTER><H1>Non-Zero Objection Viewer</H1>");
      content.add("<TABLE BORDER=1>");
      content.add("<TR>");
      content.add("<TD>Objection Kind</TD>");
      content.add("<TD>Number</TD>");
      content.add("<TD>e Path</TD>");
      content.add("</TR>");
      content.add(get_non_zero_objs_vt(obj));
      content.add("</TABLE>");
      content.add(vt.lnk_command("show data sys", "Show Sys in Browser"));
      content.add("</CENTER>");
      
      tmp_obj_viewer.set_html_body(content);
      
      tmp_obj_viewer.show();
            
   };
   
   
   show_viewer() is {
      var all_objections : list of string;
      all_objections.add("all");
      all_objections.add(all_values(objection_kind).as_a(list of string));
         
      var s : list of string;
      s.add(vt.inp_combobox("selected_obj", all_objections,""));
      s.add(vt.btn_command("sys.shr_obj_viewer.show_result(\"%selected_obj\")", "Show Objections"));
           
      var tmp_obj_viewer := new MY_PAGE vt_page with {
      	 .set_window_kind(MY_WINDOW);
	 .set_html_body(s);
      };
      
      tmp_obj_viewer.show();
   };
   
   show_result(obj : string) is {
      build_viewer_content(obj);

      var tmp_obj_viewer := new MY_PAGE vt_page with {
      	 .set_window_kind(MY_WINDOW);
	 .set_html_body(content);
      };
      
      tmp_obj_viewer.show();
   };
      
   
};//struct shr_cpu_pipeline_viewer_s

extend sys {
   shr_obj_viewer : shr_obj_viewer_s;
};

'>
